import { APISchema, SchemaNode } from '@teambit/semantics.entities.semantic-schema';
import { APINodeRenderer } from '@teambit/api-reference.models.api-node-renderer';
import { ComponentID } from '@teambit/component-id';
export declare type SchemaQueryResult = {
    getHost: {
        getSchema: JSON;
    };
};
export declare type APINode<T extends SchemaNode = SchemaNode> = {
    api: T;
    renderer: APINodeRenderer;
    componentId: ComponentID;
    exported: boolean;
};
export declare class APIReferenceModel {
    _api: APISchema;
    apiByType: Map<string, APINode[]>;
    apiByName: Map<string, APINode>;
    internalAPIKey(schema: SchemaNode): string;
    generateInternalAPIKey(filePath: string, name?: string): string;
    apiNodes: APINode[];
    taggedAPINodes: APINode<SchemaNode>[];
    componentId: ComponentID;
    constructor(_api: APISchema, _renderers: APINodeRenderer[]);
    mapTaggedAPINode(api: APISchema, renderers: APINodeRenderer[], componentId: ComponentID): APINode<SchemaNode>[];
    mapToAPINode(api: APISchema, renderers: APINodeRenderer[], componentId: ComponentID): APINode[];
    getByType(type: string): APINode<SchemaNode>[];
    groupByType(apiNodes: APINode[]): Map<string, APINode[]>;
    groupByName(apiNodes: APINode[]): Map<string, APINode>;
    static from(result: SchemaQueryResult, renderers?: APINodeRenderer[]): APIReferenceModel;
}
